web/src/openpaper/beacon/urls.py
# -*- coding: utf-8 -*-
from django.urls import path
from django.urls import re_path

from openpaper.beacon.views import bug_cluster_all
from openpaper.beacon.views import bug_cluster_graph
from openpaper.beacon.views import bug_cluster_mark_unread
from openpaper.beacon.views import bug_cluster_recompute
from openpaper.beacon.views import bug_cluster_toggle_solved
from openpaper.beacon.views import bug_cluster_view
from openpaper.beacon.views import bug_report_add_attachment
from openpaper.beacon.views import bug_report_create
from openpaper.beacon.views import bug_report_download_attachment
from openpaper.beacon.views import bug_report_index
from openpaper.beacon.views import bug_report_show
from openpaper.beacon.views import latest
from openpaper.beacon.views import post_statistics
from openpaper.beacon.views import raw_statistics
from openpaper.beacon.views import statistics
from openpaper.beacon.views import statistics_pie
from openpaper.beacon.views import statistics_historic


urlpatterns = [
    path('latest', latest, name='latest'),

    path('post_statistics', post_statistics, name='post_statistics'),
    path('statistics', statistics, name='statistics'),
    path(
        'statistics_historic', statistics_historic,
        name='statistics_historic'
    ),
    re_path(
        r'^statistics_historic'
        r';(?P<split>[a-zA-Z_]*)',
        statistics_historic, name='statistics_historic'
    ),
    path('statistics_pie', statistics_pie, name='statistics_pie'),
    re_path(
        r'^statistics_pie'
        r';(?P<unit>[a-z_]*)'
        r';(?P<min_docs>[0-9]*)'
        r';(?P<split>[a-zA-Z_]*)'
        r';(?P<filters>.*)$',
        statistics_pie, name='statistics_pie'
    ),
    path('raw_statistics', raw_statistics, name='raw_statistics'),

    path('bug_report', bug_report_index, name='bug_report_index'),
    path(
        'bug_report/create', bug_report_create,
        name='bug_report_create'
    ),
    path(
        'bug_report/add_attachment', bug_report_add_attachment,
        name="bug_report_add_attachment"
    ),
    path(
        'bug_report/show/<int:report_id>/<str:secret_key>',
        bug_report_show, name="bug_report_show"
    ),
    path(
        'bug_report/download/'
        '<int:report_id>/'
        '<str:secret_key>/'
        '<int:attachment_id>',
        bug_report_download_attachment, name="bug_report_download_attachment"
    ),

    path(
        'bug_cluster',
        bug_cluster_all,
        name="bug_cluster_all",
    ),
    path(
        'bug_cluster/<int:cluster_id>',
        bug_cluster_view,
        name="bug_cluster_view",
    ),
    path(
        'bug_cluster/<int:cluster_id>/mark_unread',
        bug_cluster_mark_unread,
        name="bug_cluster_mark_unread",
    ),
    path(
        'bug_cluster/<int:cluster_id>/toggle',
        bug_cluster_toggle_solved,
        name="bug_cluster_toggle_solved",
    ),
    path(
        'bug_cluster/<int:cluster_id>/traceback/<int:traceback_id>',
        bug_cluster_view,
        name="bug_cluster_traceback_view",
    ),
    path(
        'bug_cluster/recompute',
        bug_cluster_recompute,
        name="bug_cluster_recompute",
    ),
    path(
        'bug_cluster/graph/<str:graph_name>',
        bug_cluster_graph,
        name="bug_cluster_graph",
    ),
]

web/src/openpaper/dashboard/urls.py
from django.urls import re_path

from .views import index

urlpatterns = [
    re_path(r'^$', index, name="index"),
]

web/src/openpaper/home/urls.py
# -*- coding: utf-8 -*-
from django.urls import re_path

from .views import (
    about,
    download_linux,
    index,
    opensource,
    projects,
    redirect_to_index
)


urlpatterns = [
    re_path(r'^$', index, name="index"),
    re_path(r'^about', about, name='about'),
    re_path(r'^download$', redirect_to_index, name='download'),
    re_path(r'^download/$', redirect_to_index, name='download'),
    re_path(r'^download/linux$', download_linux, name='download_linux'),
    re_path(r'^opensource', opensource, name='opensource'),
    re_path(r'^projects', projects, name='projects'),
]

web/src/openpaper/urls.py
"""openpaper URL Configuration
"""
from django.conf.urls import include
from django.conf.urls.i18n import i18n_patterns
from django.contrib import admin
from django.contrib import sitemaps
from django.contrib.sitemaps.views import sitemap
from django.urls import (
    re_path,
    reverse
)


class RootViewSitemap(sitemaps.Sitemap):
    priority = 1.0
    changefreq = 'monthly'

    def items(self):
        return [
            'home:index',
        ]

    def location(self, item):
        return reverse(item)


class HighPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.75
    changefreq = 'monthly'

    def items(self):
        return [
        ]

    def location(self, item):
        return reverse(item)


class AveragePriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.5
    changefreq = 'monthly'

    def items(self):
        return [
            'beacon:statistics',
            'home:opensource',
        ]

    def location(self, item):
        return reverse(item)


class LowPriorityViewSitemap(sitemaps.Sitemap):
    priority = 0.25
    changefreq = 'monthly'

    def items(self):
        return [
            'home:about',
        ]

    def location(self, item):
        return reverse(item)


sitemaps = {
    'root': RootViewSitemap,
    'high_prio': HighPriorityViewSitemap,
    'average_prio': AveragePriorityViewSitemap,
    'low_prio': LowPriorityViewSitemap,
}

urlpatterns = [
    re_path(r'^admin/', admin.site.urls),
    re_path(r'^api/', include('openpaper.api.urls')),
    re_path(r'^beacon/', include('openpaper.beacon.urls')),  # alias for Paperwork
    re_path(
        r'^dashboard/',
        include(('openpaper.dashboard.urls', 'dashboard'), namespace='dashboard')
    ),
    re_path(r'^i18n/', include('django.conf.urls.i18n')),
    # re_path(r'^robots\.txt', include('robots.urls')),
    re_path(  # alias for IronScanner
        r'^scannerdb/',
        include(
            ('openpaper.scannerdb.urls', 'scannerdb'),
            namespace="scannerdb_no_i18n"
        )
    ),
    re_path(
        r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'
    ),
]

urlpatterns += i18n_patterns(
    re_path(r'^', include(('openpaper.home.urls', 'home'), namespace='home')),
    re_path(
        r'^paperwork/',
        include(('openpaper.beacon.urls', 'beacon'), namespace='beacon')
    ),
    re_path(
        r'^scanner_db/',
        include(('openpaper.scannerdb.urls', 'scannerdb'), namespace='scannerdb')
    ),
)

web/src/openpaper/api/models.py
# from django.db import models

# Create your models here.

web/src/openpaper/dashboard/models.py
# from django.db import models

# Create your models here.

web/src/openpaper/home/models.py
# from django.db import models

# Create your models here.

web/src/openpaper/scannerdb/models.py
# see backend.models.scannerdb

web/src/openpaper/scannerdb/forms.py
from django import forms


class AdminCommentForm(forms.Form):
    reason = forms.CharField(label='Admin comment', max_length=255)

web/src/openpaper/api/views/scannerdb.py
import django.core.mail
import django.http
import django.shortcuts
import django.views

import rest_framework
import rest_framework.response
import rest_framework.viewsets

import openpaper.backend.models.scannerdb
from ..serializers import scannerdb as serializers_scannerdb
from ..permissions import scannerdb as permissions_scannerdb


class ScannerManufacturerViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.ScannerManufacturer.objects.all(
    ).order_by("name")
    serializer_class = (
        serializers_scannerdb.ScannerManufacturerSerializer
    )
    permission_classes = [permissions_scannerdb.ScannerDbHasKeyOrReadOnly]


class ScannerViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.Scanner.objects.all().order_by(
        "manufacturer__name", "name"
    )
    serializer_class = serializers_scannerdb.ScannerSerializer
    permission_classes = [permissions_scannerdb.ScannerDbHasKeyOrReadOnly]


class ScanReportViewSet(rest_framework.viewsets.ModelViewSet):
    permission_classes = [permissions_scannerdb.ScannerDbReportPermission]
    # default serializer ; we override it only in retrieve()
    serializer_class = serializers_scannerdb.DefaultScanReportSerializer

    def get_queryset(self):
        queryset = openpaper.backend.models.scannerdb.ScanReport.objects.order_by(
            "-creation_date"
        )
        if self.request.method not in rest_framework.permissions.SAFE_METHODS:
            return queryset
        return queryset.filter(moderated=True)

    def create(self, request):
        # custom create view that report the secret key.
        # this is the only time ever we want to report it.
        serializer = self.get_serializer(data=request.data)
        serializer.is_valid(raise_exception=True)
        self.perform_create(serializer)
        headers = self.get_success_headers(serializer.data)

        # a bit hackish, but does the trick
        data = serializer.data
        data['secret_key'] = serializer.instance.secret_key

        url = request.build_absolute_uri(
            serializer.instance.user_url
        )
        django.core.mail.mail_admins(
            "New scan report {}".format(serializer.instance.id),
            "New scan report available:\n" + url,
            fail_silently=True
        )

        return rest_framework.response.Response(
            data, status=rest_framework.status.HTTP_201_CREATED,
            headers=headers
        )

    def retrieve(self, request, pk=None):
        report = django.shortcuts.get_object_or_404(self.get_queryset(), pk=pk)
        serializer = (
            serializers_scannerdb.DetailedScanReportSerializer(
                report, context={'request': request}
            )
        )
        return rest_framework.response.Response(serializer.data)


class ScanReportAttachmentViewSet(rest_framework.viewsets.ModelViewSet):
    queryset = openpaper.backend.models.scannerdb.ScanReportAttachment.objects.filter()
    permission_classes = [
        permissions_scannerdb.ScannerDbReportAttachmentPermission
    ]
    serializer_class = serializers_scannerdb.ScanReportAttachmentSerializer


class ScanReportDataView(rest_framework.views.APIView):
    permission_classes = [permissions_scannerdb.ScannerDbReportPermission]

    def get_report(self, request, report_id, write=True):
        self.check_permissions(request)
        report = django.shortcuts.get_object_or_404(
            openpaper.backend.models.scannerdb.ScanReport.objects, pk=report_id
        )
        if write:
            self.check_object_permissions(request, report)
        return report

    def get(self, request, report_id, node_path):
        report = self.get_report(request, report_id, write=False)
        tree = report.get_tree(request)
        return django.http.response.JsonResponse(tree)

    def post(self, request, report_id):
        report = self.get_report(request, report_id, write=True)
        data = request.data['data']
        report.set_tree(data)
        return django.http.response.HttpResponse(status=201, reason="Created")


class ScanReportAttachmentDownload(django.views.View):
    def get(self, request, attachment_id, file_name):
        attachment = django.shortcuts.get_object_or_404(
            openpaper.backend.models.scannerdb.ScanReportAttachment.objects,
            pk=attachment_id
        )
        if attachment.file_name != file_name:
            raise django.http.Http404("Attachment not found")
        response = django.http.response.HttpResponse(
            attachment.attachment, content_type=attachment.mime_type
        )
        # response['Content-Disposition'] = 'attachment; filename={}'.format(
        #     attachment.file_name
        # )
        return response

web/src/openpaper/dashboard/views.py
from django.contrib.admin.views.decorators import staff_member_required
from django.shortcuts import render

from openpaper.beacon.models import (
    BugCluster,
    BugReport,
    Statistics
)

import openpaper.backend.models.scannerdb


@staff_member_required
def index(request):
    ctx = {
        'unread_bug_reports': BugReport.objects.filter(read=False).count(),
        'unread_clusters': BugCluster.objects.filter(read=False).count(),
        'unmoderated_scan_reports': (
            openpaper.backend.models.scannerdb.ScanReport.objects.filter(
                moderated=False,
                admin_comment=None,
            ).count()
        ),
        'statistics_0': Statistics.objects.count(),
        'statistics_50': Statistics.objects.filter(
            nb_documents__gte=50
        ).count(),
        'statistics_1000': Statistics.objects.filter(
            nb_documents__gte=1000
        ).count(),
    }
    return render(request, 'dashboard.html', ctx)

web/src/openpaper/home/views.py
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.views.decorators.cache import cache_page

import openpaper.beacon.views


@cache_page(10 * 60)
def index(request):
    return render(request, 'home.html', {})


@cache_page(10 * 60)
def download_linux(request):
    ctx = {
        'latest_paperwork_version': openpaper.beacon.views.LATEST_PAPERWORK_VERSION
    }
    return render(request, 'download_linux.html', ctx)


@cache_page(10 * 60)
def opensource(request):
    return render(request, 'opensource.html', {})


@cache_page(10 * 60)
def projects(request):
    return render(request, 'projects.html', {})


@cache_page(10 * 60)
def about(request):
    return render(request, 'about.html', {})


def redirect_to_index(request):
    return HttpResponseRedirect('/')

web/src/openpaper/templates/base.html
{% load i18n %}
{% load translate_url %}
{% load static %}

<!DOCTYPE html>
{% comment %}
Translators: This string is used for the HTML page language (<html lang="XX">)
{% endcomment %}
<html lang="{% trans 'en' context "language in html header" %}">
    <head>
        <meta charset="utf-8">
        <meta content="IE=edge" http-equiv="x-ua-compatible">
        <meta name="viewport" content="width=device-width,initial-scale=1,shrink-to-fit=no">
        <title>{% block title %}UNTITLED PAGE{% endblock %} - OpenPaperwork</title>
        <link rel="stylesheet" href="{% static "openpaper_base.css" %}">
        {% check_has_translated_url %}
        {% if has_translated_url %}
        <link rel="alternate" hreflang="en" href="{% translate_url en %}" />
        <link rel="alternate" hreflang="fr" href="{% translate_url fr %}" />
        <link rel="alternate" hreflang="de" href="{% translate_url de %}" />
        <link rel="alternate" hreflang="zh-Hans" href="{% translate_url zh-hans %}" />
        {% endif %}
        <link rel="shortcut icon" type="image/png" href="{% static "favicon.png" %}"/>
        {% block extra_headers %}{% endblock %}
    </head>
    <body>
        <div class="c-site-frame">
            <nav class="c-site-frame__navigation c-site-navigation u-flex u-flex-align-items-center u-flex-justify-space-between">
                <a href="{% url 'home:index' %}" class="c-site-navigation__site-name">OpenPaper.work</a>

                <div class="u-flex u-flex-nowrap">
                    <a href="{% url 'home:index' %}" class="c-site-navigation__link">{% trans "Introduction" %}</a>
                    <a href="{% url 'home:projects' %}" class="c-site-navigation__link">{% trans "Projects" context "header link" %}</a>
                    <a href="https://gitlab.gnome.org/World/OpenPaperwork/paperwork/wikis/Contact" class="c-site-navigation__link">{% trans "Community" context "header link" %}</a>
                    <div class="c-site-navigation__link">
                        <a href="{% translate_url en %}" title="{% trans "English" %}"><img
                            src="{% static "flag_english_us.gif" %}"
                            alt="{% trans "English" %}" /></a>
                        /
                        <a href="{% translate_url zh-hans %}" title="{% trans "Simplified Chinese" %}"><img
                            src="{% static "flag_simplified_chinese.gif" %}"
                            alt="{% trans "Simplified Chinese" %}" /></a>
                        /
                        <a href="{% translate_url fr %}" title="{% trans "French" %}"><img
                            src="{% static "flag_french.gif" %}"
                            alt="{% trans "French" %}" /></a>
                        /
                        <a href="{% translate_url de %}" title="{% trans "German" %}"><img
                            src="{% static "flag_german.gif" %}"
                            alt="{% trans "German" %}" /></a>
                    </div>
                </div>
            </nav>

            {% block extra_head %}{% endblock %}
            <main class="c-site-frame__body">
                <div class="wrap-container">

                    {% block body %}{% endblock %}
                    {% block content %}{% endblock %}{# some app use 'content' #}

                </div>
            </main>

            <footer class="c-site-frame__footer c-site-footer">
                <ul>
                    {% include "footer.html" %}
                    <li><a href="https://gitlab.gnome.org/World/OpenPaperwork/paperwork">Git</a></li>
                </ul>
                <br/>
                <p>
                &copy; 2024
                <a href="https://openpaper.work">OpenPaper.work</a>
                </p>
            </footer>
        </div>

        <script data-goatcounter="https://openpaperwork.goatcounter.com/count"
                async src="//gc.zgo.at/count.js"></script>
    </body>
</html>

web/src/openpaper/templates/footer.html
{% load i18n %}

<li><a href="{% url 'home:about' %}">{% trans "About OpenPaper" %}</a></li>

web/src/openpaper/templates/piwik.html
<!-- Piwik -->
<script type="text/javascript">
  var _paq = _paq || [];
  /* tracker methods like "setCustomDimension" should be called before "trackPageView" */
  _paq.push(["setCookieDomain", "*.openpaper.work"]);
  _paq.push(['trackPageView']);
  _paq.push(['enableLinkTracking']);
  (function() {
    var u="//openpaper.work/piwik/";
    _paq.push(['setTrackerUrl', u+'piwik.php']);
    _paq.push(['setSiteId', '1']);
    var d=document, g=d.createElement('script'), s=d.getElementsByTagName('script')[0];
    g.type='text/javascript'; g.async=true; g.defer=true; g.src=u+'piwik.js'; s.parentNode.insertBefore(g,s);
  })();
</script>
<noscript><p><img src="//openpaper.work/piwik/piwik.php?idsite=1&rec=1" style="border:0;" alt="" /></p></noscript>
<!-- End Piwik Code -->